
--Snowfall Keypress

local animationsCount, animations = 5, {}
local animationNum = 1
local frame, texture, alpha1, scale1, scale2, rotation2
for i = 1, animationsCount do
	frame = CreateFrame("Frame")
	texture = frame:CreateTexture() texture:SetTexture('Interface\\Cooldown\\star4') texture:SetAlpha(0) texture:SetAllPoints() texture:SetBlendMode("ADD")
	animationGroup = texture:CreateAnimationGroup()
	alpha1 = animationGroup:CreateAnimation("Alpha") alpha1:SetFromAlpha(0) alpha1:SetToAlpha(1) alpha1:SetDuration(0) alpha1:SetOrder(1)
	scale1 = animationGroup:CreateAnimation("Scale") scale1:SetScale(1.0, 1.0) scale1:SetDuration(0) scale1:SetOrder(1)
	scale2 = animationGroup:CreateAnimation("Scale") scale2:SetScale(1.5, 1.5) scale2:SetDuration(0.3) scale2:SetOrder(2)
	rotation2 = animationGroup:CreateAnimation("Rotation") rotation2:SetDegrees(90) rotation2:SetDuration(0.3) rotation2:SetOrder(2)
	animations[i] = {frame = frame, animationGroup = animationGroup}
end
local AnimateButton = function(self)
	if not self:IsVisible() then return true end
	local animation = animations[animationNum]
	local frame = animation.frame
	local animationGroup = animation.animationGroup
	frame:SetFrameStrata("HIGH")
	frame:SetFrameLevel(20)
	frame:SetAllPoints(self)
	animationGroup:Stop()
	animationGroup:Play()
	animationNum = (animationNum % animationsCount) + 1
	return true
end

hooksecurefunc('MultiActionButtonDown', function(bname, id)
	 AnimateButton(_G[bname..'Button'..id])
end)

hooksecurefunc('PetActionButtonDown', function(id)
	 local button
		 if PetActionBarFrame then
			 if id > NUM_PET_ACTION_SLOTS then return end
			 button = _G["PetActionButton"..id]
			 if not button then return end
		 end
		 return
	 AnimateButton(button)
end)

hooksecurefunc('ActionButtonDown', function(id)
	 local button
	 if C_PetBattles.IsInBattle() then
		 if PetBattleFrame then
			 if id > NUM_BATTLE_PET_HOTKEYS then return end
			 button = PetBattleFrame.BottomFrame.abilityButtons[id]
			 if id == BATTLE_PET_ABILITY_SWITCH then
					button = PetBattleFrame.BottomFrame.SwitchPetButton;
			 elseif id == BATTLE_PET_ABILITY_CATCH then
					button = PetBattleFrame.BottomFrame.CatchButton;
			 end
			 if not button then return end
		 end
		 return
	 end
	 if OverrideActionBar and OverrideActionBar:IsShown() then
		 if id > NUM_OVERRIDE_BUTTONS then return end
		 button = _G["OverrideActionBarButton"..id]
	 else
		 button = _G["ActionButton"..id]
	 end
	 if not button then return end
	 AnimateButton(button)
end)


--hidestancebar

StanceBarFrame:SetScript("OnEvent", nil);
StanceBarFrame:SetScript("OnShow",StanceBarFrame.Hide)
StanceBarFrame:Hide()

--buffsndebuffspartyframes

for i=1,4 do
        local f = _G["PartyMemberFrame"..i]
        f:UnregisterEvent("UNIT_AURA")
        local g = CreateFrame("Frame")
        g:RegisterEvent("UNIT_AURA")
        g:SetScript("OnEvent",function(self,event,a1)
                if a1 == f.unit then
                        RefreshDebuffs(f,a1,20,nil,1)
                else
                        if a1 == f.unit.."pet" then
                                PartyMemberFrame_RefreshPetDebuffs(f)
                        end
                end
        end)
        local b = _G[f:GetName().."Debuff1"]
        b:ClearAllPoints()
        b:SetPoint("LEFT",f,"RIGHT",-7,5)
        for j=5,20 do
                local l = f:GetName().."Debuff"
                local n = l..j
                local c = CreateFrame("Frame",n,f,"PartyDebuffFrameTemplate")
                c:SetPoint("LEFT",_G[l..(j-1)],"RIGHT")
        end
end

for i=1,4 do
        local f = _G["PartyMemberFrame"..i]
        f:UnregisterEvent("UNIT_AURA")
        local g = CreateFrame("Frame")
        g:RegisterEvent("UNIT_AURA")
        g:SetScript("OnEvent",function(self,event,a1)
                if a1 == f.unit then
                        RefreshBuffs(f,a1,20,nil,1)
                end
        end)
        for j=1,20 do
                local l = f:GetName().."Buff"
                local n = l..j
                local c = CreateFrame("Frame",n,f,"TargetBuffFrameTemplate")
                c:EnableMouse(false)
                if j == 1 then
                        c:SetPoint("TOPLEFT",48,-32)
                else
                        c:SetPoint("LEFT",_G[l..(j-1)],"RIGHT",1,0)
                end
        end
end



--Important buffs
--[[
BuffTracker
bl = icon list 
bs = icon size
xb = x positon of buff Tracker
yb = y positon of buff Tracker
br = x buffs per line
]]--
bl={139,33206,47536,62618,165718,47788,232707,208065,197030,213602,213610,41635,114255,221660,108208,185313,121471,1966,31224,5277,212283,211442,235966}
bs=25;xb=70;yb=-64;br=6;bdr="BORDER"be="UNIT_AURA"cbf=CreateFrame;gi=GetSpellInfo;bm=math.ceil;fm=math.floor;st=STANDARD_TEXT_FONT;function cu(s)return UnitBuff("player",gi(s))end
function Cb(i,s)local _,_,t3=gi(s)local f=cbf("Frame")f:SetSize(bs,bs)f.t=f:CreateTexture(nil,bdr)f.t:SetAllPoints(true)f.t:SetTexture(t3)f.f=f:CreateFontString(nil,bdr)f.f:SetFont(st,9,"OUTLINE")f.f:SetPoint("CENTER",0,0)return f;end
function vb(s,i,row)local b1,_,_,b4=cu(s)local f=_G["B"..i]if b1 then f:Show()f:SetPoint("CENTER",xb+(bs+5)*bm((row-1)%br),yb-(bs+1)*bm(row/br))if(b4>1)then f.f:SetText(b4)end row=row+1;end return row;end
function ub()for i,s in ipairs(bl)do local b,_,_,_,_,_,k=cu(s)if b then local vt=fm(k-GetTime())if(vt>=60)then vt=bm(vt/60)_G["B"..i].c:SetText(vt.."m")elseif vt >=0 then _G["B"..i].c:SetText(vt.."s")end end end end
function Cc(f)f.c=f:CreateFontString(nil,bdr)f.c:SetFont(st,12,"OUTLINE")f.c:SetPoint("CENTER",0,0)end function db()for i in ipairs(bl)do _G["B"..i]:Hide()end end
for i,s in ipairs(bl)do _G["B"..i]=Cb(i,s)Cc(_G["B"..i])_G["B"..i]:Hide()end function bb()db()local bw=1;for i,s in ipairs(bl)do bw=vb(s,i,bw)end end bk=cbf("Frame")bk:SetScript("OnEvent",bb)bk:SetScript("OnUpdate",ub)bk:RegisterEvent(be)





--frameflashred

PlayerFrameFlash:Hide(); PlayerFrameFlash.Show = function() end
TargetFrameFlash:Hide(); TargetFrameFlash.Show = function() end
FocusFrameFlash:Hide(); FocusFrameFlash.Show = function() end



--castbarself

CastingBarFrame:ClearAllPoints()
CastingBarFrame:SetPoint("CENTER",UIParent,"CENTER", 0,0)
CastingBarFrame:SetScale(1.5)

--castbarfocus

FocusFrameSpellBar:ClearAllPoints()
FocusFrameSpellBar:SetPoint("CENTER", UIParent, "CENTER", 0, 100)
FocusFrameSpellBar.SetPoint = function() end
FocusFrameSpellBar:SetScale(1.5)


--castbartarget
TargetFrameSpellBar:ClearAllPoints()
TargetFrameSpellBar:SetPoint("CENTER", TargetFrame, "TOP", -10, 10)
TargetFrameSpellBar.SetPoint = function() end
TargetFrameSpellBar:SetScale(1.06)

--hidemacrotext

local noop = function() end
hooksecurefunc("ActionButton_Update", function(btn)
	local hotkey = _G[btn:GetName().."HotKey"]
	hotkey:SetText("")
	hotkey.Show = noop
	hotkey:Hide()
end)

hooksecurefunc("ActionButton_Update", function(btn)
	local name = _G[btn:GetName().."Name"]
	name:Hide()
end)

 --omniCC

cs=14;ps=10;ctp="CENTER"ptp="BOTTOMRIGHT"cp=1;ct=UNIT_NAME_FONT;crt=2;cDB={}action={}ccf=CreateFrame;gac=GetActionCooldown;ol="OUTLINE"cpe="PLAYER_ENTERING_WORLD"cau="ACTIONBAR_UPDATE_COOLDOWN"co="OnUpdate"

function rt(f)f.e=nil f.t:SetText("")f:SetScript(co,nil)end function sf(f,v)f.t:SetFont(ct,f.s*v,ol)end function acv(b)local x=b.cooldown x.a=b.action action[x]=x end function scv(p,f,po,s)if(s>1)then f.t:SetPoint(po,p)end f.s=s;end

function sr(f,e)if(e>60)then sf(f,0.7)if(f.s==cs)then return"%d:%02d",e,e else return"%dm",e+60,e end elseif(e>=cp)then sf(f,1)f.t:SetTextColor(1,1,0,1)return"%d",e elseif(e>0)then sf(f,0.9)f.t:SetTextColor(1,0,0,1)return"%.1f",e else return end end
function suc(f)if not f.e then f.e=1;f:SetScript(co,function(s,e)f.c=f.c+e;local fo,v1,v2=sr(f,f.r-f.c)if not fo then rt(f)elseif not v2 then f.t:SetFormattedText(fo,v1)else f.t:SetTextColor(1,1,1,1)f.t:SetFormattedText(fo,v1/60,v2%60)end end)end end

function scs(p,f)if(p:GetSize()<35)then scv(p,f,ptp,ps)else scv(p,f,ctp,cs)end end function gict(f)local c=ccf("Frame",nil,f)c:SetFrameLevel(f:GetFrameLevel()+5)c.t=c:CreateFontString(nil,"OVERLAY")c.t:SetAllPoints(c)scs(f:GetParent(),c)return c;end

function gct(f)if not cDB[f]then local c=gict(f)c:SetSize(c.s*crt,c.s*crt)sf(c,1)cDB[f]=c;end return cDB[f]end function cvf(f,s,d)local c=gct(f)if(s and d)then c.b=s;c.d=d;if(s>0 and d>1.5)then c.c=0;c.r=d-(GetTime()-s);suc(c)else rt(c)end end end

function cvc(DB)for c in pairs(DB)do if c.a then local s,d=gac(c.a)cvf(c,s,d)end end end function pcv(_,e)if e==cau then cvc(action)else cvc(cDB)end end for _,b in pairs(ActionBarButtonEventsFrame.frames)do acv(b)end

vc=ccf("Frame")vc:SetScript("OnEvent",pcv)vc:RegisterEvent(cpe)vc:RegisterEvent(cau)hooksecurefunc(getmetatable(ActionButton1Cooldown).__index,"SetCooldown",cvf)hooksecurefunc("SetActionUIButton",acv)





-- incombat

inCombat = CreateFrame("Frame", nil, PlayerFrame)
inCombat:SetPoint("CENTER",128,14)
inCombat:SetSize(30,30)
inCombat.t = inCombat:CreateTexture(nil,BORDER)
inCombat.t:SetAllPoints()
inCombat.t:SetTexture("Interface\\Icons\\ABILITY_DUALWIELD")
inCombat:SetAlpha(0)
inCombat:SetScript("OnUpdate", function(self)
if UnitAffectingCombat("player") then
self:SetAlpha(1)
else
self:SetAlpha(0)
end
end)

-- incombattarget

inCombat = CreateFrame("Frame", nil, TargetFrame)
inCombat:SetPoint("CENTER",-128,14)
inCombat:SetSize(30,30)
inCombat.t = inCombat:CreateTexture(nil,BORDER)
inCombat.t:SetAllPoints()
inCombat.t:SetTexture("Interface\\Icons\\ABILITY_DUALWIELD")
inCombat:SetAlpha(0)
inCombat:SetScript("OnUpdate", function(self)
if UnitAffectingCombat("Target") then
self:SetAlpha(1)
else
self:SetAlpha(0)
end
end)

-- incombatfocus

inCombat = CreateFrame("Frame", nil, FocusFrame)
inCombat:SetPoint("CENTER",98,14)
inCombat:SetSize(30,30)
inCombat.t = inCombat:CreateTexture(nil,BORDER)
inCombat.t:SetAllPoints()
inCombat.t:SetTexture("Interface\\Icons\\ABILITY_DUALWIELD")
inCombat:SetAlpha(0)
inCombat:SetScript("OnUpdate", function(self)
if UnitAffectingCombat("focus") then
self:SetAlpha(1)
else
self:SetAlpha(0)
end
end)


--frames

PlayerFrame:SetPoint("RIGHT",UIParent,"CENTER",-160,-95)PlayerFrame.SetPoint=function()end

TargetFrame:ClearAllPoints()TargetFrame:SetPoint("RIGHT",UIParent,"CENTER",390,-95)TargetFrame.SetPoint=function()end

FocusFrame:ClearAllPoints()FocusFrame:SetPoint("RIGHT",UIParent,"CENTER",-260,130)FocusFrame.SetPoint=function()end


		
--hidden

hooksecurefunc("PlayerFrame_UpdateStatus",function()
 -- make changes to PlayerFrame here

 
 PlayerRestGlow:Hide()
 PlayerAttackGlow:Hide()
 PlayerStatusGlow:Hide()

end)





--Targeting Frames
--Change the Value in the barckets to change the size.
PlayerFrame:SetScale(1.35)
TargetFrame:SetScale(1.35)
FocusFrame:SetScale(1.21)



---- Disable healing/damage spam over player/pet frame
PlayerHitIndicator:SetText(nil)
PlayerHitIndicator.SetText = function() end

PetHitIndicator:SetText(nil)
PetHitIndicator.SetText = function() end

--[[macro/binds]]

for i=1, 12 do
        _G["ActionButton"..i.."HotKey"]:SetAlpha(0) -- main bar
        _G["MultiBarBottomRightButton"..i.."HotKey"]:SetAlpha(0) -- bottom right bar
        _G["MultiBarBottomLeftButton"..i.."HotKey"]:SetAlpha(0) -- bottom left bar
        _G["MultiBarRightButton"..i.."HotKey"]:SetAlpha(0) -- right bar
        _G["MultiBarLeftButton"..i.."HotKey"]:SetAlpha(0) -- left bar
end

--
UIErrorsFrame:SetAlpha(0)
--





--micromenubar

local t = {
	"MainMenuBarBackpackButton",
	"CharacterBag0Slot",
	"CharacterBag1Slot",
	"CharacterBag2Slot",
	"CharacterBag3Slot",
}

local function showFoo(self)
	for _, v in ipairs(t) do
		_G[v]:SetAlpha(1)
	end
end

local function hideFoo(self)
	for _, v in ipairs(t) do
		_G[v]:SetAlpha(0)
	end
end

for _, v in ipairs(t) do
	v = _G[v]
	v:SetScript("OnEnter", showFoo)
	v:SetScript("OnLeave", hideFoo)
	v:SetAlpha(0)
end

local function showFoo(self)
	for _, v in ipairs(MICRO_BUTTONS) do
		_G[v]:SetAlpha(1)
	end
end

local function hideFoo(self)
	for _, v in ipairs(MICRO_BUTTONS) do
		_G[v]:SetAlpha(0)
	end
end

for _, v in ipairs(MICRO_BUTTONS) do
	v = _G[v]
	v:SetScript("OnEnter", showFoo)
	v:SetScript("OnLeave", hideFoo)
	v:SetAlpha(0)
end


--micromenubarmove

CharacterMicroButton:ClearAllPoints()
CharacterMicroButton:SetPoint("BOTTOM",320,1055)

--honorbar

local b=HonorWatchBar b:UnregisterAllEvents() b:Hide() b.Show=b.Hide

--artibar

local b=ArtifactWatchBar b:UnregisterAllEvents() b:Hide() b.Show=b.Hide




--autosellshit


local g = CreateFrame("Frame")
g:RegisterEvent("MERCHANT_SHOW")

g:SetScript("OnEvent", function()  
        local bag, slot
        for bag = 0, 4 do
                for slot = 0, GetContainerNumSlots(bag) do
                        local link = GetContainerItemLink(bag, slot)
                        if link and (select(3, GetItemInfo(link)) == 0) then
                                UseContainerItem(bag, slot)
                        end
                end
        end

        if(CanMerchantRepair()) then
                local cost = GetRepairAllCost()
                if cost > 0 then
                        local money = GetMoney()
                        if IsInGuild() then
                                local guildMoney = GetGuildBankWithdrawMoney()
                                if guildMoney > GetGuildBankMoney() then
                                        guildMoney = GetGuildBankMoney()
                                end
                                if guildMoney > cost and CanGuildBankRepair() then
                                        RepairAllItems(1)
                                        print(format("|cfff07100Repair cost covered by G-Bank: %.1fg|r", cost * 0.0001))
                                        return
                                end
                        end
                        if money > cost then
                                RepairAllItems()
                                print(format("|cffead000Repair cost: %.1fg|r", cost * 0.0001))
                        else
                                print("Not enough gold to cover the repair cost.")
                        end
                end
        end
end)




--outofrangeindicator

hooksecurefunc("ActionButton_OnEvent",function(self, event, ...)
if ( event == "PLAYER_TARGET_CHANGED" ) then
self.newTimer = self.rangeTimer
end
end)
hooksecurefunc("ActionButton_UpdateUsable",function(self)
local icon = _G[self:GetName().."Icon"]
local valid = IsActionInRange(self.action)
if ( valid == false ) then
icon:SetVertexColor(1.0, 0.1, 0.1)
end
end)
hooksecurefunc("ActionButton_OnUpdate",function(self, elapsed)
local rangeTimer = self.newTimer
if ( rangeTimer ) then
rangeTimer = rangeTimer - elapsed
if ( rangeTimer <= 0 ) then
ActionButton_UpdateUsable(self)
rangeTimer = TOOLTIP_UPDATE_TIME
end
self.newTimer = rangeTimer
end
end)

--raidframerealmnamehide

local known = {}
local function update()
 local i, button = 1
 repeat
 button = _G["CompactRaidFrame"..i]
 if button and not known[button] then
 known[button] = true
 button.name:SetHeight(6)
 end
 i=i+1
 until not button
end
local f = CreateFrame("Frame")
f:SetScript("OnEvent",update)
f:RegisterEvent("PLAYER_LOGIN")
hooksecurefunc("CompactUnitFrame_SetUnit",function(frame, unit)
 frame.name:SetHeight(6)
end)

-- minimap

MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
Minimap:EnableMouseWheel(true)
Minimap:SetScript('OnMouseWheel', function(self, delta)
        if delta > 0 then
                Minimap_ZoomIn()
        else
                Minimap_ZoomOut()
        end
end)
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("TOPRIGHT", -26, 7)


--bars1

MainMenuBar:SetScale(1)
MultiBarBottomLeft:SetPoint("TOPLEFT",8,100)
MultiBarBottomLeft:SetScale(1)
MultiBarBottomRight:SetPoint("LEFT",8,90)
MultiBarBottomRightButton1:SetScale(1)
--

MultiBarBottomRightButton3: SetScale(1)
MultiBarBottomRightButton5:SetScale(1)
MultiBarBottomRightButton7:SetScale(1)
MultiBarBottomRightButton9:SetScale(1)
MultiBarBottomRightButton11:SetScale(1)
--

MultiBarBottomRightButton2:SetScale(1)
MultiBarBottomRightButton4:SetScale(1)
MultiBarBottomRightButton6:SetScale(1)
MultiBarBottomRightButton8:SetScale(1)
MultiBarBottomRightButton10:SetScale(1)
MultiBarBottomRightButton12:SetScale(1)

MainMenuBarLeftEndCap:Hide();MainMenuBarRightEndCap:Hide()

--petbarwow

PetActionBarFrame:ClearAllPoints()
PetActionBarFrame:SetPoint ("CENTER", UIParent , -63, -465)
PetActionBarFrame:SetScale(.9)
PetActionBarFrame.ClearAllPoints = function () end
PetActionBarFrame.SetPoint = function () end

PetFrame:ClearAllPoints()
PetFrame:SetPoint ("CENTER", PlayerFrame, "BOTTOM",  -28, 0)
PetFrame.ClearAllPoints = function () end
PetFrame.SetPoint = function () end

--mainmenumover


MainMenuBar:SetPoint("BOTTOM",250,-50)



--micromenubar

local t = {
	"MainMenuBarBackpackButton",
	"CharacterBag0Slot",
	"CharacterBag1Slot",
	"CharacterBag2Slot",
	"CharacterBag3Slot",
}

local function showFoo(self)
	for _, v in ipairs(t) do
		_G[v]:SetAlpha(1)
	end
end

local function hideFoo(self)
	for _, v in ipairs(t) do
		_G[v]:SetAlpha(0)
	end
end

for _, v in ipairs(t) do
	v = _G[v]
	v:SetScript("OnEnter", showFoo)
	v:SetScript("OnLeave", hideFoo)
	v:SetAlpha(0)
end

local function showFoo(self)
	for _, v in ipairs(MICRO_BUTTONS) do
		_G[v]:SetAlpha(1)
	end
end

local function hideFoo(self)
	for _, v in ipairs(MICRO_BUTTONS) do
		_G[v]:SetAlpha(0)
	end
end

for _, v in ipairs(MICRO_BUTTONS) do
	v = _G[v]
	v:SetScript("OnEnter", showFoo)
	v:SetScript("OnLeave", hideFoo)
	v:SetAlpha(0)
end


--micromenubarmove

CharacterMicroButton:ClearAllPoints()
CharacterMicroButton:SetPoint("BOTTOM",320,1055)

